Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingCollection<E>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingCollection<E>

All Implemented Interfaces:
  Iterable<E>, Collection<E>

Direct Known Subclasses:
  ForwardingList, ForwardingMultiset, ForwardingQueue, ForwardingSet

    public abstract class ForwardingCollection<E>

extends ForwardingObject
implements Collection<E>

A collection which forwards all its method calls to another collection. Subclasses should override one or more methods to modify the behavior of the backing collection as desired per the decorator pattern.

Author:
  Kevin Bourrillion
See Also:
  `ForwardingObject`

Constructor Summary
`ForwardingCollection()`

Method Summary
`boolean` | `add(E element)` Ensures that this collection contains the specified element (optional operation).
`boolean` | `addAll(Collection<? extends E> collection)` Adds all of the elements in the specified collection to this collection (optional operation).
`void` | `clear()` Removes all of the elements from this collection (optional operation).
`boolean` | `contains(Object object)` Returns `true` if this collection contains the specified element.
`boolean` | `containsAll(Collection<?> collection)` Returns `true` if this collection contains all of the elements in the specified collection.
`protected abstract Collection<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`boolean` | `isEmpty()` Returns `true` if this collection contains no elements.
`Iterator<E>` | `iterator()` Returns an iterator over the elements in this collection.
`boolean` | `remove(Object object)` Removes a single instance of the specified element from this collection, if it is present (optional operation).
`boolean` | `removeAll(Collection<?> collection)` Removes all of this collection's elements that are also contained in the specified collection (optional operation).
`boolean` | `retainAll(Collection<?> collection)` Retains only the elements in this collection that are contained in the specified collection (optional operation).
`int` | `size()` Returns the number of elements in this collection.
`Object[]` | `toArray()` Returns an array containing all of the elements in this collection.
`
`<T> T[]`
` | `toArray(T[] array)` Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`equals, hashCode`

Constructor Detail

### ForwardingCollection

    public ForwardingCollection()

Method Detail

### delegate

    protected abstract Collection<E> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingObject`

### iterator

    public Iterator<E> iterator()

  Description copied from interface: `java.util.Collection`
  Returns an iterator over the elements in this collection. There are no guarantees concerning the order in which the elements are returned (unless this collection is an instance of some class that provides a guarantee).

  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Returns:
    an `Iterator` over the elements in this collection

### size

    public int size()

  Description copied from interface: `java.util.Collection`
  Returns the number of elements in this collection. If this collection contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `Collection<E>`
  Returns:
    the number of elements in this collection

### removeAll

    public boolean removeAll(Collection<?> collection)

  Description copied from interface: `java.util.Collection`
  Removes all of this collection's elements that are also contained in the specified collection (optional operation). After this call returns, this collection will contain no elements in common with the specified collection.

  Specified by:
    `removeAll` in interface `Collection<E>`
  Parameters:
    `collection` - collection containing elements to be removed from this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `Collection.remove(Object)`, `Collection.contains(Object)`

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `java.util.Collection`
  Returns `true` if this collection contains no elements.

  Specified by:
    `isEmpty` in interface `Collection<E>`
  Returns:
    `true` if this collection contains no elements

### contains

    public boolean contains(Object object)

  Description copied from interface: `java.util.Collection`
  Returns `true` if this collection contains the specified element. More formally, returns `true` if and only if this collection contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  Specified by:
    `contains` in interface `Collection<E>`
  Parameters:
    `object` - element whose presence in this collection is to be tested
  Returns:
    `true` if this collection contains the specified element

### toArray

    public Object[] toArray()

  Description copied from interface: `java.util.Collection`
  Returns an array containing all of the elements in this collection. If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  The returned array will be "safe" in that no references to it are maintained by this collection. (In other words, this method must allocate a new array even if this collection is backed by an array). The caller is thus free to modify the returned array.

  This method acts as bridge between array-based and collection-based APIs.

  Specified by:
    `toArray` in interface `Collection<E>`
  Returns:
    an array containing all of the elements in this collection

### toArray

    public <T> T[] toArray(T[] array)

  Description copied from interface: `java.util.Collection`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array. If the collection fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this collection.

  If this collection fits in the specified array with room to spare (i.e., the array has more elements than this collection), the element in the array immediately following the end of the collection is set to `null`. (This is useful in determining the length of this collection only if the caller knows that this collection does not contain any `null` elements.)

  If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  Like the `Collection.toArray()` method, this method acts as bridge between array-based and collection-based APIs. Further, this method allows precise control over the runtime type of the output array, and may, under certain circumstances, be used to save allocation costs.

  Suppose `x` is a collection known to contain only strings. The following code can be used to dump the collection into a newly allocated array of `String`:

           String[] y = x.toArray(new String[0]);

  Note that `toArray(new Object[0])` is identical in function to `toArray()`.

  Specified by:
    `toArray` in interface `Collection<E>`
  Parameters:
    `array` - the array into which the elements of this collection are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing all of the elements in this collection

### add

    public boolean add(E element)

  Description copied from interface: `java.util.Collection`
  Ensures that this collection contains the specified element (optional operation). Returns `true` if this collection changed as a result of the call. (Returns `false` if this collection does not permit duplicates and already contains the specified element.)

  Collections that support this operation may place limitations on what elements may be added to this collection. In particular, some collections will refuse to add `null` elements, and others will impose restrictions on the type of elements that may be added. Collection classes should clearly specify in their documentation any restrictions on what elements may be added.

  If a collection refuses to add a particular element for any reason other than that it already contains the element, it must throw an exception (rather than returning `false`). This preserves the invariant that a collection always contains the specified element after this call returns.

  Specified by:
    `add` in interface `Collection<E>`
  Parameters:
    `element` - element whose presence in this collection is to be ensured
  Returns:
    `true` if this collection changed as a result of the call

### remove

    public boolean remove(Object object)

  Description copied from interface: `java.util.Collection`
  Removes a single instance of the specified element from this collection, if it is present (optional operation). More formally, removes an element `e` such that `(o==null ? e==null : o.equals(e))`, if this collection contains one or more such elements. Returns `true` if this collection contained the specified element (or equivalently, if this collection changed as a result of the call).

  Specified by:
    `remove` in interface `Collection<E>`
  Parameters:
    `object` - element to be removed from this collection, if present
  Returns:
    `true` if an element was removed as a result of this call

### containsAll

    public boolean containsAll(Collection<?> collection)

  Description copied from interface: `java.util.Collection`
  Returns `true` if this collection contains all of the elements in the specified collection.

  Specified by:
    `containsAll` in interface `Collection<E>`
  Parameters:
    `collection` - collection to be checked for containment in this collection
  Returns:
    `true` if this collection contains all of the elements in the specified collection
  See Also:
    `Collection.contains(Object)`

### addAll

    public boolean addAll(Collection<? extends E> collection)

  Description copied from interface: `java.util.Collection`
  Adds all of the elements in the specified collection to this collection (optional operation). The behavior of this operation is undefined if the specified collection is modified while the operation is in progress. (This implies that the behavior of this call is undefined if the specified collection is this collection, and this collection is nonempty.)

  Specified by:
    `addAll` in interface `Collection<E>`
  Parameters:
    `collection` - collection containing elements to be added to this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `Collection.add(Object)`

### retainAll

    public boolean retainAll(Collection<?> collection)

  Description copied from interface: `java.util.Collection`
  Retains only the elements in this collection that are contained in the specified collection (optional operation). In other words, removes from this collection all of its elements that are not contained in the specified collection.

  Specified by:
    `retainAll` in interface `Collection<E>`
  Parameters:
    `collection` - collection containing elements to be retained in this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `Collection.remove(Object)`, `Collection.contains(Object)`

### clear

    public void clear()

  Description copied from interface: `java.util.Collection`
  Removes all of the elements from this collection (optional operation). The collection will be empty after this method returns.

  Specified by:
    `clear` in interface `Collection<E>`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD